###################################################
### chunk number 1: 
###################################################
#line 54 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
library(actuar)
options(width = 62, digits = 4)


###################################################
### chunk number 2: 
###################################################
#line 266 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
x <- grouped.data(Group = c(0, 25, 50, 100, 150, 250, 500),
                  Line.1 = c(30, 31, 57, 42, 65, 84),
                  Line.2 = c(26, 33, 31, 19, 16, 11))


###################################################
### chunk number 3: 
###################################################
#line 273 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
class(x)


###################################################
### chunk number 4: 
###################################################
#line 278 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
x


###################################################
### chunk number 5: 
###################################################
#line 288 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
x[, 1]                                  # group boundaries


###################################################
### chunk number 6: 
###################################################
#line 293 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
x[, -1]                                 # group frequencies


###################################################
### chunk number 7: 
###################################################
#line 297 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
x[1:3,]                                 # first 3 groups


###################################################
### chunk number 8: 
###################################################
#line 307 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
x[1, 2] <- 22; x                        # frequency replacement
x[1, c(2, 3)] <- c(22, 19); x           # frequency replacement


###################################################
### chunk number 9: 
###################################################
#line 312 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
x[1, 1] <- c(0, 20); x                  # boundary replacement
x[c(3, 4), 1] <- c(55, 110, 160); x


###################################################
### chunk number 10: 
###################################################
#line 326 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
mean(x)


###################################################
### chunk number 11: 
###################################################
#line 337 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
hist(x[, -3])


###################################################
### chunk number 12: 
###################################################
#line 342 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
hist(x[, -3])


###################################################
### chunk number 13: 
###################################################
#line 378 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
Fnt <- ogive(x)
knots(Fnt)                              # group boundaries
Fnt(knots(Fnt))                         # ogive at group boundaries
plot(Fnt)                               # plot of the ogive


###################################################
### chunk number 14: 
###################################################
#line 386 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
plot(Fnt)


###################################################
### chunk number 15: 
###################################################
#line 396 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
quantile(x)
Fnt(quantile(x))


###################################################
### chunk number 16: 
###################################################
#line 409 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
data("dental"); dental
data("gdental"); gdental


###################################################
### chunk number 17: 
###################################################
#line 420 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
emm(dental, order = 1:3)                # first three moments
emm(gdental, order = 1:3)               # idem


###################################################
### chunk number 18: 
###################################################
#line 430 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
lev <- elev(dental)
lev(knots(lev))                         # ELEV at data points
plot(lev, type = "o", pch = 19)         # plot of the ELEV function

lev <- elev(gdental)
lev(knots(lev))                         # ELEV at data points
plot(lev, type = "o", pch = 19)         # plot of the ELEV function


###################################################
### chunk number 19: 
###################################################
#line 441 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
par(mfrow = c(1, 2))
plot(elev(dental), type = "o", pch = 19)
plot(elev(gdental), type = "o", pch = 19)


###################################################
### chunk number 20: 
###################################################
#line 511 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
op <- options(warn = -1)                # hide warnings from mde()


###################################################
### chunk number 21: 
###################################################
#line 514 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
mde(gdental, pexp, start = list(rate = 1/200), measure = "CvM")
mde(gdental, pexp, start = list(rate = 1/200), measure = "chi-square")
mde(gdental, levexp, start = list(rate = 1/200), measure = "LAS")


###################################################
### chunk number 22: 
###################################################
#line 519 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
options(op)                             # restore warnings


###################################################
### chunk number 23:  eval=FALSE
###################################################
## #line 526 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
## mde(gdental, ppareto, start = list(shape = 3, scale = 600),
##         measure = "CvM") # no convergence


###################################################
### chunk number 24: 
###################################################
#line 530 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
out <- try(mde(gdental, ppareto, start = list(shape = 3, scale = 600),
        measure = "CvM"), silent = TRUE)
cat(sub(", measure", ",\n             measure", out))


###################################################
### chunk number 25: 
###################################################
#line 539 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
pparetolog <- function(x, logshape, logscale)
    ppareto(x, exp(logshape), exp(logscale))
( p <- mde(gdental, pparetolog, start = list(logshape = log(3),
                                logscale = log(600)), measure = "CvM") )


###################################################
### chunk number 26: 
###################################################
#line 546 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
exp(p$estimate)


###################################################
### chunk number 27: 
###################################################
#line 643 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
f <- coverage(pdf = dgamma, cdf = pgamma, deductible = 1, limit = 10)
f
f(0, shape = 5, rate = 1)
f(5, shape = 5, rate = 1)
f(9, shape = 5, rate = 1)
f(12, shape = 5, rate = 1)


###################################################
### chunk number 28: 
###################################################
#line 660 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
x <- rgamma(100, 2, 0.5)
y <- pmin(x[x > 1], 9)
op <- options(warn = -1)                # hide warnings from fitdistr()


###################################################
### chunk number 29: 
###################################################
#line 665 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
library(MASS)
fitdistr(y, f, start = list(shape = 2, rate = 0.5))


###################################################
### chunk number 30: 
###################################################
#line 669 "d:/Rcompile/CRANpkg/local/2.12/actuar/inst/doc/lossdist.Rnw"
options(op)                             # restore warnings


